#! /usr/bin/python3
import math

def find_internal_tangent_points(x1, y1, r1, x2, y2, r2):
    # Tính khoảng cách giữa hai tâm
    d = math.sqrt((x2 - x1)**2 + (y2 - y1)**2)

    # Kiểm tra nếu hai đường tròn có thể có tiếp tuyến trong
    if d <= abs(r1 - r2):
        return None

    # Góc của đường nối tâm
    base_angle = math.atan2(y2 - y1, x2 - x1)

    # Góc của tiếp tuyến trong
    angle = math.acos((r1 - r2) / d)

    # Các tiếp tuyến trong
    tangent_points = []
    for delta in [angle, -angle]:
        angle_t = base_angle + delta
        x_t1 = x1 + r1 * math.cos(angle_t)
        y_t1 = y1 + r1 * math.sin(angle_t)
        x_t2 = x2 - r2 * math.cos(angle_t)
        y_t2 = y2 - r2 * math.sin(angle_t)
        tangent_points.append((x_t1, y_t1))
        tangent_points.append((x_t2, y_t2))

    return tangent_points

# Giá trị cụ thể
#x1, y1, r1 = 111.9, 18.900000000000002, 0.9009009009009009
#x2, y2, r2 = 111.9, 20.400000000000002, 0.9009009009009009

x1, y1, r1 = 111.9, 18.900000000000002, 0.9009009009009009
x2, y2, r2 = 111.9, 20.400000000000002, 0.9009009009009009

tangent_points = find_internal_tangent_points(x1, y1, r1, x2, y2, r2)

if tangent_points:
    for i, point in enumerate(tangent_points, start=1):
        print(f"Tangent point {i}: {point}")
else:
    print("Không có tiếp tuyến trong.")
